﻿package 
{
	import flash.display.Bitmap;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.display.TriangleCulling;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.utils.Timer;
	
	public class Main extends Sprite 
	{
		[Embed(source = 'assets/lena.png')]public var Lena:Class;
		public var image:Bitmap;
		
		public const W:uint = 36;//X方向の分割数
		public const H:uint = 36;//Y方向の分割数
		public const MOVE:Number = 10;//最初に設定された位置から移動できる量(ドット)
		public const SPEED:Number = 0.12;//目標に近づくスピード
		public const NEAR_LENGTH:Number = 80;//近いかどうかを判断する閾値（直線距離）
		public var imageWidth:uint;//画像のX方向のドット数
		public var imageHeight:uint;//画像のY方向のドット数
		public var points:Vector.<TrianglePoint> = new Vector.<TrianglePoint>();//複数の点
		public var triangles:Vector.<Triangle> = new Vector.<Triangle>();//複数の三角形
		public var zoom:Number = 2;//拡大率
		public var timer:Timer = new Timer(2000 , 0);//形状が変化するタイマー
		public var isMouseDown:Boolean = false;
		
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			this.stage.scaleMode = StageScaleMode.NO_SCALE;
			this.stage.quality = StageQuality.LOW;
			this.stage.align = StageAlign.TOP_LEFT;
			
			this.image = new Lena();
			this.image.smoothing = true;
			this.image.alpha = 0.25;
			this.imageWidth = this.image.width;
			this.imageHeight = this.image.height;
			this.image.scaleX = this.image.scaleY = this.zoom;
			var intX:Number = this.imageWidth  / (this.W - 1);
			var intY:Number = this.imageHeight / (this.H - 1);
			
			//座標を作成
			for (var y:int = 0; y < this.H; y++) 
			{
				for (var x:int = 0; x < this.W; x++) 
				{
					var t:TrianglePoint = new TrianglePoint(x * intX, y * intY);
					if (x == 0 || y == 0 || x == this.W - 1 || y == this.H - 1) t.isEdge = true;//上下左右の端かどうか
					this.points.push(t);
				}
			}
			//座標から三角形を作成
			// 0---1
			// │   │
			// 2---3
			//
			//次の２組の三角形を作成
			// 0---1
			// │  
			// 2
			//     1
			//     │
			// 2---3
			//
			for (y = 0; y < this.H-1; y++) 
			{
				for (x = 0; x < this.W-1; x++) 
				{
					var topLeft:int = x + y*this.W;
					var bottomLeft:int = x + (y+1)*this.W;
					var topRight:int = topLeft + 1;
					var bottomRight:int = bottomLeft + 1;
					this.triangles[this.triangles.length] = new Triangle(
						this.points[topLeft],
						this.points[topRight],
						this.points[bottomLeft]
					);
					this.triangles[this.triangles.length] = new Triangle(
						this.points[topRight],
						this.points[bottomRight],
						this.points[bottomLeft]
					);
				}
			}
			
			this.addEventListener(Event.ENTER_FRAME , this.enterFrameHandler);
			this.stage.addEventListener(MouseEvent.MOUSE_DOWN , function(event:MouseEvent):void { isMouseDown = true; });
			this.stage.addEventListener(MouseEvent.MOUSE_UP , function(event:MouseEvent):void { isMouseDown = false; } );
			this.stage.addEventListener(MouseEvent.DOUBLE_CLICK , this.doubleClickHandler);
			this.timer.addEventListener(TimerEvent.TIMER , function(event:TimerEvent):void { move(); });
			this.timer.start();
			this.stage.doubleClickEnabled = true;
		}
		
		private function doubleClickHandler(event:MouseEvent):void
		{
			if (this.image.stage)
			{
				this.removeChild(this.image);
			}
			else
			{
				this.addChild(this.image);
			}
		}
		
		private function enterFrameHandler(event:Event):void
		{
			this.mouseInteractive();//マウス座標に応じて移動する
			this.update();//ターゲットへ向かって移動する
			this.checkColor();//現在地の色を計算する
			this.draw();//描画する
		}
		
		/**
		 * TrianglePoint.targetPointに向けて移動する
		 */
		private function update():void
		{
			for (var i:int = 0; i < this.points.length; i++) 
			{
				var point:TrianglePoint = this.points[i];
				if (point.isEdge) continue;
				
				point.x += (point.targetPoint.x - point.x) * this.SPEED ;
				point.y += (point.targetPoint.y - point.y) * this.SPEED ;
				
			}
		}
		
		/**
		 * マウスに反応してthis.pointsを移動する
		 */
		private function mouseInteractive():void
		{
			var nearLength:Number = (this.isMouseDown)? this.NEAR_LENGTH * 2.5 :this.NEAR_LENGTH;
			var resist:Number = (this.isMouseDown)? 40 : -15;//抵抗
			
			var mousePoint:Point = new Point((mouseX / zoom) , (mouseY / zoom));//マウス座標。ZOOMを考慮
			//近くにあるPointだけを取得するFilter
			var filterFunc:Function = function(item:TrianglePoint , index:int , vector:Vector.<TrianglePoint>):Boolean
			{
				var x:Number = mousePoint.x - item.x;
				var y:Number = mousePoint.y - item.y;
				var length:Number = Math.sqrt(x * x + y * y);
				return (length < nearLength)?true:false;
			}
			
			//近くにあるポイントを取得する
			var nearPoints:Vector.<TrianglePoint> = this.points.filter(filterFunc, this);
			for (var i:int = 0; i < nearPoints.length; i++) 
			{
				var nearPoint:TrianglePoint = nearPoints[i];
				if (nearPoint.isEdge) continue;
				
				var x:Number = mousePoint.x - nearPoint.x;//マウスとのX距離
				var y:Number = mousePoint.y - nearPoint.y;//マウスとのY距離
				var length:Number = Math.sqrt(x * x + y * y);//マウスとの距離
				length = nearLength - length;//近いほど値が大きくなるように
				
				var angle:Number = Math.atan2(y, x)+Math.PI;//角度
				x = Math.cos(angle) * length ;//X方向の距離
				y = Math.sin(angle) * length ;//Y方向の距離
				
				nearPoint.x -= x / resist;
				nearPoint.y -= y / resist;
			}
		}
		
		/**
		 * this.point.targetPointを変更する。
		 * ランダムで目標地点が変わる。
		 */
		private function move():void
		{
			for (var i:int = 0; i < this.points.length; i++) 
			{
				var point:TrianglePoint = this.points[i];
				if (point.x == 0 || point.y == 0) continue;
				if (int(point.x) == this.imageWidth || int(point.y) == this.imageHeight) continue;
				
				point.targetPoint.x = point.defaultPoint.x + (Math.random()*this.MOVE-this.MOVE/2) ;
				point.targetPoint.y = point.defaultPoint.y + (Math.random()*this.MOVE-this.MOVE/2) ;
				
			}
		}
		
		/**
		 * 三角形の色をチェックする
		 */
		private function checkColor():void
		{
			for (var i:int = 0; i < this.triangles.length; i++) 
			{
				var t:Triangle = this.triangles[i];
				var newColor:uint = this.calcTriangleColor(t.points[0], t.points[1], t.points[2]);
				t.color = (newColor != 0)?newColor:t.color;
			}
		}
		
		/**
		 * 三角形を描画する
		 */
		private function draw():void
		{
			var g:Graphics = this.graphics;
			g.clear();
			for (var i:int = 0; i < this.triangles.length; i++) 
			{
				var t:Triangle = this.triangles[i];
				g.beginFill(t.color);
				g.moveTo(t.points[0].x*this.zoom, t.points[0].y*this.zoom);
				g.lineTo(t.points[1].x*this.zoom, t.points[1].y*this.zoom);
				g.lineTo(t.points[2].x*this.zoom, t.points[2].y*this.zoom);
				g.endFill();
			}
		}
		
		public function calcTriangleColor(point1:Point, point2:Point, point3:Point):uint
		{
			
			//Pointを上中下に振り分ける
			var topPoint:Point = (point1.y < point2.y)?point1:point2;
			topPoint = (point3.y < topPoint.y)?point3:topPoint;
			var bottomPoint:Point = (point1.y > point2.y)?point1:point2;
			bottomPoint = (point3.y > bottomPoint.y)?point3:bottomPoint;
			var middlePoint:Point;
			if (point1 != topPoint && point1 != bottomPoint) middlePoint = point1
			else if (point2 != topPoint && point2 != bottomPoint)  middlePoint = point2
			else middlePoint = point3;
			
			//右と左の範囲の座標を調べる
			var left:Number = (point1.x < point2.x)?point1.x:point2.x;
			left = (point3.x < left)?point3.x:left;
			var right:Number = (point1.x > point2.x)?point1.x:point2.x;
			right = (point3.x > right)?point3.x:right;
			//上と下の範囲の座標を調べる
			var top:Number = topPoint.y;
			var bottom:Number = bottomPoint.y;
			var middle:Number = middlePoint.y;
			//整数にする
			left = int(left);
			right = int(right);
			top = int(top);
			bottom = int(bottom);
			middle = int(middle);
			//角度
			var angleTop2Bottom:Number    = Math.PI/2 - Math.atan2(int(bottomPoint.y)-int(topPoint.y),int(bottomPoint.x)-int(topPoint.x));
			var angleTop2Middle:Number    = Math.PI/2 - Math.atan2(int(topPoint.y)-int(middlePoint.y),int(topPoint.x)-int(middlePoint.x));
			var angleMiddle2Bottom:Number = Math.PI/2 - Math.atan2(int(bottomPoint.y)-int(middlePoint.y),int(bottomPoint.x)-int(middlePoint.x));
			
			
			//loop用
			var sumColor:uint = 0;
			var loop:uint = 0;
			var red:uint = 0;
			var green:uint = 0;
			var blue:uint = 0;
			var y:int;
			var x:int;
			var l:Number;
			var r:Number;
			
			//上から下へループ
			for (y = top; y < bottom; y++) 
			{
				//TOPからMIDDLEまでの区間
				if (y < int(middlePoint.y))
				{
					//middleが左にあった場合
					if (middlePoint.x < bottomPoint.x)
					{
						l = Math.tan(angleTop2Middle)*(y-top)+int(topPoint.x);
						r = Math.tan(angleTop2Bottom)*(y-top)+int(topPoint.x);
					}
					//bottomが左にあった場合
					else
					{
						l = Math.tan(angleTop2Bottom)*(y-top)+int(topPoint.x);
						r = Math.tan(angleTop2Middle)*(y-top)+int(topPoint.x);
					}
				}
				//MIDDLEからBOTTOMまでの区間
				else
				{
					//middleが左にあった場合　又は　bottomが左にあった場合
					l = Math.tan(angleMiddle2Bottom)*(y-middle)+int(middlePoint.x);
					r = Math.tan(angleTop2Bottom)*(y-top)+int(topPoint.x);
				}
				
				//左右入れ替わっている可能性があるので入れ替える
				var tmpL:int = (l < r)?l:r;
				var tmpR:int = (l < r)?r:l;
				l = int(tmpL);
				r = int(tmpR);
				
				//配列につっこむ
				for (x = l; x < r; x++) 
				{
					var c:uint = this.image.bitmapData.getPixel(x, y);
					red   += c >> 16;
					green += c >> 8 & 0xFF;
					blue  += c & 0xFF;
					loop++;
				}
			}
			
			return int(red / loop)<<16 | int(green / loop)<<8 | int(blue / loop);
			
		}
		
	}
	
}